#include "AlcoholClick_Demo_objects.h"
#include "AlcoholClick_Demo_resources.h"

//--------------------- User code ---------------------//

unsigned sensor_adc_value, adc_changes;
const double Rl      = 5000.0;               // Rl (Ohm) - Load resistance
const double Vadc_5  = 0.0048828125;         // ADC step 5V/1024 4,88mV (10bit ADC)
const double Vadc_33 = 0.0032226562;         // ADC step 3,3V/1024 3,22mV (10bit ADC)
double Vrl;                                  // Output voltage
double Rs;                                   // Rs (Ohm) - Sensor resistance
double ppm;                                  // ppm
double ratio;                                // Rs/Rl ratio
char txt[16];


//Calculation of PPM
void calculatePPM() {
  double lgPPM;
  Vrl = (double)sensor_adc_value * Vadc_33;  // For 5V Vcc use Vadc_5  and  for 3V Vcc use Vadc_33
  Rs = Rl * (5 - Vrl)/Vrl;                   // Calculate sensor resistance
  ratio = Rs/Rl;                             // Calculate ratio
  lgPPM = (log10(ratio) * -2.6)+ 2.7;        // Calculate ppm
  ppm = pow(10,lgPPM);                       // Calculate ppm
}

// Read Sensor ADC
void readsensor() {
  sensor_adc_value = ADC1_Read(3);
  delay_ms(10);                              // Pause 10ms
}

void Tone1() {
  Sound_Play(659, 150);   // Frequency = 659Hz, duration = 150ms
}

void Tone2() {
  Sound_Play(700, 130);   // Frequency = 700Hz, duration = 130ms
}

void Tone3() {
  Sound_Play(750, 110);   // Frequency = 750Hz, duration = 110ms
}

void Tone4() {
  Sound_Play(800, 90);   // Frequency = 800Hz, duration = 90ms
}

void Tone5() {
  Sound_Play(850, 70);   // Frequency = 850Hz, duration = 70ms
  delay_ms(10);
  Sound_Play(850, 70);   // Frequency = 850Hz, duration = 70ms
  delay_ms(10);
  Sound_Play(850, 70);   // Frequency = 850Hz, duration = 70ms
}

void Tone_Peak() {
  Sound_Play(900, 50);   // Frequency = 900Hz, duration = 50ms
  delay_ms(10);
  Sound_Play(900, 50);   // Frequency = 900Hz, duration = 50ms
  delay_ms(10);
  Sound_Play(900, 50);   // Frequency = 900Hz, duration = 50ms
  delay_ms(10);
  Sound_Play(900, 50);   // Frequency = 900Hz, duration = 50ms
}


void beer_graph() {
    Sound_Init(&PORTD, 1);
    while (1) {
    readSensor();                            // Read sensor
    calculatePPM();                          // Calculating PPM value
    if (adc_changes != sensor_adc_value) {
        DrawImage(&Image15);
        if  (ppm <   400)                   {TFT_Circle( 46, 125, 6); Tone1();      } else
        if ((ppm >   400) && (ppm <   500)) {TFT_Circle( 72, 133, 6); Tone2();      } else
        if ((ppm >   500) && (ppm <   650)) {TFT_Circle( 92, 147, 6); Tone3();      } else
        if ((ppm >   650) && (ppm <   800)) {TFT_Circle(120, 168, 6); Tone4();      } else
        if ((ppm >   800) && (ppm <   900)) {TFT_Circle(180, 155, 6); Tone5();      } else
        if ((ppm >   900) && (ppm <  1000)) {TFT_Circle(170, 184, 6); Tone5();      } else
        if ((ppm >  1000) && (ppm <  1200)) {TFT_Circle(180, 170, 6); Tone5();      } else
        if ((ppm >  1200) && (ppm <  1300)) {TFT_Circle(182,  70, 6); Tone5();      } else
        if ((ppm >  1300) && (ppm <  1500)) {TFT_Circle(184,  38, 6); Tone_Peak();  } else
        if ((ppm >  1500) && (ppm <  1600)) {TFT_Circle(189, 130, 6); Tone5();      } else
        if ((ppm >  1600) && (ppm <  1700)) {TFT_Circle(205, 184, 6); Tone4();      } else
        if ((ppm >  1700) && (ppm <  2500)) {TFT_Circle(240, 186, 6); Tone3();      } else
        if  (ppm >  2500)                   {TFT_Circle(281, 188, 6); Tone2();      }
        adc_changes = sensor_adc_value;
        }
    }
}



//----------------- End of User code ------------------//

// Event Handlers
